#!/usr/bin/perl
#
# http://www.translatum.gr/converter/greek-transliteration.htm
#

$opt=$ARGV[0];


while ($s=<STDIN>) {
	# Πρώτα αλλάζουμε τα φωνήεντα με διαλυτικά
	$s=~ s/ϊ|ΐ|Ϊ/I/g;
	$s=~ s/ϋ|Ϋ/I/g;
	
	# Μετά τα κάνουμε όλα κεφαλαία
	$s=~ s/α|ά|Ά/Α/g;
	$s=~ s/β/Β/g;
	$s=~ s/γ/Γ/g;
	$s=~ s/δ/Δ/g;
	$s=~ s/ε|έ|Έ/Ε/g;
	$s=~ s/ζ/Ζ/g;
	$s=~ s/η|ή|Ή/Η/g;
	$s=~ s/θ/Θ/g;
	$s=~ s/ι|ί|Ί/Ι/g;
	$s=~ s/κ/Κ/g;
	$s=~ s/λ/Λ/g;
	$s=~ s/μ/Μ/g;
	$s=~ s/ν/Ν/g;
	$s=~ s/ξ/Ξ/g;
	$s=~ s/ο|ό|Ό/Ο/g;
	$s=~ s/π/Π/g;
	$s=~ s/ρ/Ρ/g;
	$s=~ s/σ|ς/Σ/g;
	$s=~ s/τ/Τ/g;
	$s=~ s/υ|ύ/Υ/g;
	$s=~ s/φ/Φ/g;
	$s=~ s/χ/Χ/g;
	$s=~ s/ψ/Ψ/g;
	$s=~ s/ω|ώ|Ώ/Ω/g;

	if ($opt eq "-c") {
		print ($s);
		exit;
	}

	# Ειδικές περιπτώσεις διφθόγγων
	$s=~ s/ΑΥΘ/AFTH/g;
	$s=~ s/ΑΥΚ/AFK/g;
	$s=~ s/ΑΥΞ/AFX/g;
	$s=~ s/ΑΥΠ/AFP/g;
	$s=~ s/ΑΥΣ/AFS/g;
	$s=~ s/ΑΥΤ/AFT/g;
	$s=~ s/ΑΥΦ/AF/g;
	$s=~ s/ΑΥΧ/AFX/g;
	$s=~ s/ΑΥΨ/AFPS/g;

	$s=~ s/ΕΥΘ/ΕFTH/g;
	$s=~ s/ΕΥΚ/ΕFK/g;
	$s=~ s/ΕΥΞ/ΕFX/g;
	$s=~ s/ΕΥΠ/ΕFP/g;
	$s=~ s/ΕΥΣ/ΕFS/g;
	$s=~ s/ΕΥΤ/ΕFT/g;
	$s=~ s/ΕΥΦ/ΕF/g;
	$s=~ s/ΕΥΧ/ΕFX/g;
	$s=~ s/ΕΥΨ/ΕFPS/g;

	$s=~ s/ΗΥΘ/IFTH/g;
	$s=~ s/ΗΥΚ/IFK/g;
	$s=~ s/ΗΥΞ/IFX/g;
	$s=~ s/ΗΥΠ/IFP/g;
	$s=~ s/ΗΥΣ/IFS/g;
	$s=~ s/ΗΥΤ/IFT/g;
	$s=~ s/ΗΥΦ/IF/g;
	$s=~ s/ΗΥΧ/IFX/g;
	$s=~ s/ΗΥΨ/IFTH/g;

	# Απλές περιπτώσεις διφθόγγων
	$s=~ s/ΑΙ/E/g;
	$s=~ s/ΕΙ/I/g;
	$s=~ s/ΟΙ/I/g;
	$s=~ s/ΥΙ/I/g;
	$s=~ s/ΟΥ/OU/g;
	$s=~ s/ΑΥ/AV/g;
	$s=~ s/ΕΥ/EV/g;
	$s=~ s/ΗΥ/IV/g;

	# Περιπτώσεις διγραμμάτων
#	$s=~ s/ΓΓ|ΓΚ/NG/g;			Δεν έβγαινε και πολύ καλό αυτό
	$s=~ s/ΓΓ|ΓΚ/G/g;
	$s=~ s/ΓΧ/NH/g;
	$s=~ s/ΜΠ/B/g;
	$s=~ s/ΝΤ/D/g;
	$s=~ s/ΣΛ/ZL/g;
	$s=~ s/ΤΖ/TJ/g;
	$s=~ s/ΤΘ/TTH/g;


	# Απλές περιπτώσεις
	$s=~ s/Α/A/g;
	$s=~ s/Β/V/g;
	$s=~ s/Γ/G/g;
	$s=~ s/Δ/D/g;
	$s=~ s/Ε/E/g;
	$s=~ s/Ζ/Z/g;
	$s=~ s/Η/I/g;
	$s=~ s/Θ/TH/g;
	$s=~ s/Ι/I/g;
	$s=~ s/Κ/K/g;
	$s=~ s/Λ/L/g;
	$s=~ s/Μ/M/g;
	$s=~ s/Ν/N/g;
	$s=~ s/Ξ/X/g;
	$s=~ s/Ο/O/g;
	$s=~ s/Π/P/g;
	$s=~ s/Ρ/R/g;
	$s=~ s/Σ/S/g;
	$s=~ s/Τ/T/g;
	$s=~ s/Υ/I/g;
	$s=~ s/Φ/F/g;
	$s=~ s/Χ/CH/g;
	$s=~ s/Ψ/PS/g;
	$s=~ s/Ω|ώ/O/g;
	print $s;
}
