#!/usr/bin/env python
# -*- coding: utf-8 -*- 

logfile='log.txt'
dbhostname='1.2.3.4'
dbusername='system'
dbpassword='PASSWORD'
dbservicename='KOZANI'
dbport='1521'

# export LD_LIBRARY_PATH=/usr/lib/oracle/12.2/client64/lib/
#import os
import cx_Oracle
import argparse
import sys
import os
import time


from subprocess import Popen, PIPE

os.environ["NLS_LANG"] = "GREEK_GREECE.AL32UTF8"


ap = argparse.ArgumentParser()
ap.add_argument("-m")
args = ap.parse_args()


if args.m=='preview':
	mode='preview'
	print '====== Preview mode ======'
elif args.m=='update':
	mode='update'
	f=open(logfile,"a")
	print '====== UPDATE MODE ======'
else:
	print "Usage: fixenglishnames -m preview|update"
	sys.exit(0)

connection = cx_Oracle.connect(dbusername+"/"+dbpassword+"@"+dbhostname+":"+dbport+"/"+dbservicename)
cursor = connection.cursor()
cursor.execute("SELECT * FROM OTS.MIS_EMPLOYEES WHERE usage_code IN (SELECT usage_code FROM ots.mis_workusages WHERE usage_year = (SELECT max(usage_year) from ots.mis_workusages)) AND N_GUNET_ENABLED=1")
data = cursor.fetchall()


nmobile=0
nfixes=0
nempty=0
ncorrect=0
nwrong=0
n=len(data)

for line in data:
	auto_id=line[0]
	id=line[1]	
	usage_code=line[10]
	v_gunet_employeetype=line[202]
	n_gunet_updated=line[222]
	v_gunet_tincountry=line[226]
	v_gunet_ssncountry=line[225]
	v_loginname=line[221]
	v_name_english=line[209]
	v_surname_english=line[210]
	name=line[3]
	surname=line[2]
	cellphone=line[76]
	usage_code=line[63]
	afm=line[26]
	email=line[77]
	v_amka=line[105]

	if v_name_english is None and v_surname_english is None:
		p = Popen(['./el2en.pl'], stdin=PIPE, stdout=PIPE)
		p.stdin.write(name)
		p.stdin.close()
		s1 = p.stdout.read()

		p = Popen(['./el2en.pl'], stdin=PIPE, stdout=PIPE)
		p.stdin.write(surname)
		p.stdin.close()
		s2 = p.stdout.read()

		query="UPDATE OTS.MIS_EMPLOYEES SET v_name_english='"+s1+"',v_surname_english='"+s2+"' WHERE auto_id="+str(auto_id)+" AND name='"+name+"' AND surname='"+surname+"'"
		if mode=='update':
			s=time.strftime('%Y-%m-%d_%H:%M:%S')
			f.write(s+" "+query+'\n')
			cursor.execute(query)
			connection.commit()
		print str(auto_id)+" - "+name+" "+surname +" ("+usage_code+"): "+query


cursor.close();
connection.close()

if mode=='update':
	f.close()

