#!/usr/bin/python

logfile='log.txt'
dbhostname='1.2.3.4'
dbusername='system'
dbpassword='PASSWORD'
dbservicename='KOZANI'
dbport='1521'

# export LD_LIBRARY_PATH=/usr/lib/oracle/12.2/client64/lib/
#import os
import cx_Oracle
import argparse
import sys
import re
import time

ap = argparse.ArgumentParser()
ap.add_argument("-m")
args = ap.parse_args()


if args.m=='preview':
	mode='preview'
	print '====== Preview mode ======'
elif args.m=='update':
	mode='update'
	f=open(logfile,"a")
	print '====== UPDATE MODE ======'
else:
	print "Usage: fixmobiles -m preview|update"
	sys.exit(0)

connection = cx_Oracle.connect(dbusername+"/"+dbpassword+"@"+dbhostname+":"+dbport+"/"+dbservicename)
cursor = connection.cursor()
cursor.execute("SELECT * FROM OTS.MIS_EMPLOYEES WHERE usage_code IN (SELECT usage_code FROM ots.mis_workusages WHERE usage_year = (SELECT max(usage_year) from ots.mis_workusages)) AND N_GUNET_ENABLED=1")
data = cursor.fetchall()


nmobile=0
nfixes=0
nempty=0
ncorrect=0
nwrong=0
n=len(data)


for line in data:
	auto_id=line[0]
	id=line[1]	
	usage_code=line[10]
	name=line[3]
	surname=line[2]
	v_gunet_employeetype=line[202]
	n_gunet_updated=line[222]
	v_gunet_tincountry=line[226]
	v_gunet_ssncountry=line[225]
	v_loginname=line[221]
	cellphone=line[76]
	usage_code=line[63]
	afm=line[26]
	email=line[77]
	v_amka=line[105]

	if v_amka is None:
		v_amka=""
	if cellphone is None:
		cellphone=""

	fix=False;
	if cellphone is "":
		# No mobile phone
		nempty+=1
		print "EMPTY MOBILE: "+name+" "+surname+" ("+str(auto_id)+", \""+usage_code+"\", \""+v_amka+"\", \""+cellphone+"\")"
		continue
	else:
		nmobile+=1
	if len(cellphone)==13 and cellphone.startswith("+3069"):
		# Mobile number is Ok
		ncorrect+=1
		continue
	else:
		nwrong+=1
		print "WRONG MOBILE: "+name+" "+surname+" ("+str(auto_id)+", \""+usage_code+"\", \""+v_amka+"\", \""+cellphone+"\")"

	# Strip unwanted characters and attempt to fix
	cellphonenew = re.sub('[^\+0-9]', '', cellphone)

	if len(cellphonenew)==13 and cellphonenew.startswith("+3069"):
		nfixes+=1
		fix=True;

	if len(cellphone)==10 and cellphone.startswith("69"):
		# Mobile number looks like 69xxxxxxxx
		nfixes+=1
		fix=True;
		cellphonenew="+30"+cellphone
	if fix:
		query="UPDATE OTS.MIS_EMPLOYEES SET cellphone='"+cellphonenew+"' WHERE auto_id="+str(auto_id)+" AND cellphone='"+cellphone+"'"
		if mode=='update':
			s=time.strftime('%Y-%m-%d_%H:%M:%S')
			f.write(s+" "+query+'\n')
			cursor.execute(query)
			connection.commit()
		print query

#	print cellphonenew
cursor.close();
connection.close()

if mode=='update':
	f.close()

print "====== Report ======"
print "---------------------"
print "Total records:   %d" % n
print "---------------------"
print "Total mobiles:   %d" % nmobile
print "Empty mobiles:   %d" % nempty
print "---------------------"
print "Correct mobiles: %d" % ncorrect
print "Wrong mobiles:   %d" % nwrong
print "---------------------"
print "Fixable mobiles: %d" % nfixes

